//+------------------------------------------------------------------+
//| This MQL is generated by Expert Advisor Builder                  |
//|                http://sufx.core.t3-ism.net/ExpertAdvisorBuilder/ |
//|                                                                  |
//|  In no event will author be liable for any damages whatsoever.   |
//|                      Use at your own risk.                       |
//|                                                                  |
//|                Please do not remove this header.                 |
//+------------------------------------------------------------------+
#property copyright "Harry Hidayat, SE"
#property link      "harryhid@yahoo.com"

extern int MagicNumber = 737;
extern bool EachTickMode = True;
extern double Lots = 1;
extern int Slippage = 5;
extern int MaxSpread = 3;
extern bool StopLossMode = True;
extern int StopLoss = 30;
extern bool TakeProfitMode = True;
extern int TakeProfit = 30;
extern bool TrailingStopMode = True;
extern int TrailingStop = 15;

#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4

int BarCount;
int Current;
bool TickCheck = False;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   BarCount = Bars;

   if (EachTickMode) Current = 0; else Current = 1;

   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   int Order = SIGNAL_NONE;
   int Total, Ticket;
   double StopLossLevel, TakeProfitLevel;



   if (EachTickMode && Bars != BarCount) TickCheck = False;
   Total = OrdersTotal();
   Order = SIGNAL_NONE;

   //+------------------------------------------------------------------+
   //| Variable Begin                                                   |
   //+------------------------------------------------------------------+

      double RSI1  = iRSI(NULL, 0, 2, PRICE_MEDIAN, Current + 0);
      double RSI2  = iRSI(NULL, 0, 5, PRICE_MEDIAN, Current + 0);
      double Var1 = iStochastic(NULL, 0, 2, 2, 2, MODE_EMA, 0, MODE_SIGNAL, Current + 0);
      double Var2 = iEnvelopes(NULL, 0, 3, MODE_SMMA, 0, PRICE_MEDIAN, 0.03, MODE_UPPER, Current + 0);
      double Var3 = iEnvelopes(NULL, 0, 3, MODE_SMMA, 0, PRICE_MEDIAN, 0.03, MODE_LOWER, Current + 0);
      double Var4 = iMA(NULL, 0, 1, 0, MODE_EMA, PRICE_MEDIAN, Current + 0);
      double Var5 = iMA(NULL, 0, 1, 0, MODE_EMA, PRICE_MEDIAN, Current + 1);
      double Buy1_1 =  Var1 ;
      double Buy1_2 = 50;
      double Buy2_1 =  Var2 ;
      double Buy2_2 =  Var4 ;
      double Buy3_1 =  Var4 ;
      double Buy3_2 =  Var5 ;
      double Buy4_1 = Ask;
      double Buy4_2 =  Var2 +5*Point;
      double Sell1_1 =  Var1 ;
      double Sell1_2 = 50;
      double Sell2_1 =  Var3 ;
      double Sell2_2 =  Var4 ;
      double Sell3_1 =  Var4 ;
      double Sell3_2 =  Var5 ;
      double Sell4_1 = Bid;
      double Sell4_2 =  Var3 -5*Point;
      double CloseBuy1_1 =  Var1 ;
      double CloseBuy1_2 = 50;
      double CloseBuy2_1 =  Var3 ;
      double CloseBuy2_2 =  Var4 ;
      double CloseBuy3_1 =  Var4 ;
      double CloseBuy3_2 =  Var5 ;
      double CloseSell1_1 =  Var1 ;
      double CloseSell1_2 = 50;
      double CloseSell2_1 =  Var2 ;
      double CloseSell2_2 =  Var4 ;
      double CloseSell3_1 =  Var4 ;
      double CloseSell3_2 =  Var5 ;

   //+------------------------------------------------------------------+
   //| Variable End                                                     |
   //+------------------------------------------------------------------+

   //Check position
   for (int i = 0; i < Total; i ++) {
      OrderSelect(0, SELECT_BY_POS, MODE_TRADES);
      if(OrderType() <= OP_SELL &&  OrderSymbol() == Symbol()) {
         if(OrderType() == OP_BUY) {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Buy)                                           |
            //+------------------------------------------------------------------+

               if (CloseBuy1_1 > CloseBuy1_2 && CloseBuy2_1 > CloseBuy2_2 && CloseBuy3_1 < CloseBuy3_2 && RSI2 < 50 && RSI1 < 50) Order = SIGNAL_CLOSEBUY;

            //+------------------------------------------------------------------+
            //| Signal End(Exit Buy)                                             |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, MediumSeaGreen);Alert("BUY order closed : ", OrderClosePrice());
               if (!EachTickMode) BarCount = Bars;
               break;
            }
            //Trailing stop
            if(TrailingStopMode && TrailingStop > 0) {                 
               if(Bid - OrderOpenPrice() > Point * TrailingStop) {
                  if(OrderStopLoss() < Bid - Point * TrailingStop) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Point * TrailingStop, OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!EachTickMode) BarCount = Bars;
                     break;
                  }
               }
            }
         } else {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Sell)                                          |
            //+------------------------------------------------------------------+

               if (CloseSell1_1 < CloseSell1_2 && CloseSell2_1 < CloseSell2_2 && CloseSell3_1 > CloseSell3_2 && RSI2 > 50 && RSI1 > 50) Order = SIGNAL_CLOSESELL;

            //+------------------------------------------------------------------+
            //| Signal End(Exit Sell)                                            |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSESELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, DarkOrange);Alert("SELL order closed : ", OrderClosePrice());
               if (!EachTickMode) BarCount = Bars;
               break;
            }
            //Trailing stop
            if(TrailingStopMode && TrailingStop > 0) {                 
               if((OrderOpenPrice() - Ask) > (Point * TrailingStop)) {
                  if((OrderStopLoss() > (Ask + Point * TrailingStop)) || (OrderStopLoss() == 0)) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Point * TrailingStop, OrderTakeProfit(), 0, DarkOrange);
                     if (!EachTickMode) BarCount = Bars;
                     break;
                  }
               }
            }
         }
      }
   }

   //+------------------------------------------------------------------+
   //| Signal Begin(Entry)                                              |
   //+------------------------------------------------------------------+

      if (Buy1_1 < Buy1_2 && Buy2_1 < Buy2_2 && Buy3_1 > Buy3_2 && Buy4_1 < Buy4_2 && Ask-Bid<=MaxSpread*Point) Order = SIGNAL_BUY;
      if (Sell1_1 > Sell1_2 && Sell2_1 > Sell2_2 && Sell3_1 < Sell3_2 && Sell4_1 > Sell4_2 && Ask-Bid<=MaxSpread*Point) Order = SIGNAL_SELL;

   //+------------------------------------------------------------------+
   //| Signal End                                                       |
   //+------------------------------------------------------------------+

   //Buy
   if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(Total < 1) {
         //Check free margin
         if (AccountFreeMargin() < (10 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (StopLossMode) StopLossLevel = Ask - StopLoss * Point; else StopLossLevel = 0.0;
         if (TakeProfitMode) TakeProfitLevel = Ask + TakeProfit * Point; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, StopLossLevel, TakeProfitLevel, "Trend Master H1(Magic:" + MagicNumber + ")", MagicNumber, 0, DodgerBlue);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) Alert("BUY order opened : ", OrderOpenPrice()); else Print("Error opening BUY order : ", GetLastError());
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   //Sell
   if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(Total < 1) {
         //Check free margin
         if (AccountFreeMargin() < (10 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (StopLossMode) StopLossLevel = Bid + StopLoss * Point; else StopLossLevel = 0.0;
         if (TakeProfitMode) TakeProfitLevel = Bid - TakeProfit * Point; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, StopLossLevel, TakeProfitLevel, "Trend Master H1(Magic:" + MagicNumber + ")", MagicNumber, 0, DeepPink);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) Alert("SELL order opened : ", OrderOpenPrice()); else Print("Error opening SELL order : ", GetLastError());
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   if (!EachTickMode) BarCount = Bars;

   return(0);
}
//+------------------------------------------------------------------+